// res_test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "stdlib.h"
#include "math.h"

double ROPTION;
double R0;
double R1;
double R2;
double R3;
double R4;
double R5;
double R6;
double R7;
double R_BYPASS; 
double R2_BYPASS;
double R3_BYPASS;




//			5K		10K		20K		50K
//========================================
//R_BYPASS	49900	100000	200000	499000
//R2_BYPASS	7500	15000	30100	75000
//R3_BYPASS	4120	8200	16500	41200
//ROPTION		49900	100000	200000	499000
//R0		24900	49900	100000	249000
//R1		12400	24900	49900	124000
//R2		6190	12400	24900	61900
//R3		3090	6190	12400	30900
//R4		1540	3090	6190	15400
//R5		768		1540	3090	7680
//R6		383		768		1540	3830
//R7		191		383		768		1910


void Set5KVals( void )
{
//			5K		10K		20K		50K
//========================================
R_BYPASS	=49900.0;
R2_BYPASS	=7500.0	;
R3_BYPASS	=4120.0	;
ROPTION		=49900.0;
R0			=24900.0;
R1			=12400.0;
R2			=6190.0	;
R3			=3090.0	;
R4			=1540.0	;
R5			=768.0	;
R6			=383.0	;
R7			=191.0	;
}

void Set10KVals( void )
{
//			5K		10K		20K		50K
//========================================
R_BYPASS	=100000.0;
R2_BYPASS	=15000.0;
R3_BYPASS	=8250.0;
ROPTION		=100000.0;
R0			=49900.0;
R1			=24900.0;
R2			=12400.0;
R3			=6190.0;
R4			=3090.0;
R5			=1540.0;
R6			=768.0;
R7			=383.0;
}

void Set20KVals( void )
{
//			5K		10K		20K		50K
//========================================
R_BYPASS	=200000.0;	
R2_BYPASS	=30100.0;	
R3_BYPASS	=16500.0;	
ROPTION		=200000.0;	
R0			=100000.0;	
R1			=49900.0;	
R2			=24900.0;	
R3			=12400.0;	
R4			=6190.0;	
R5			=3090.0;	
R6			=1540.0;	
R7			=768.0;	
}

void Set50KVals( void )
{
//			5K		10K		20K		50K
//========================================
R_BYPASS	=499000.0;
R2_BYPASS	=75000.0;
R3_BYPASS	=41200.0;
ROPTION		=499000.0;
R0			=249000.0;
R1			=124000.0;
R2			=61900.0;
R3			=30900.0;
R4			=15400.0;
R5			=7680.0;
R6			=3830.0;
R7			=1910.0;
}






int compare (const void * a, const void * b)
{
    if (*(double*)a  > *(double*)b) return -1;
	if (*(double*)a  < *(double*)b) return 1;
	return 0;		
}




double getladderimpedance( int i )
{
//double rtable[8];
double temp;

    

    temp = 0.0;

	  // calc the resistance of the ladder
    if (i&0x1)  temp += 1.0/R0;
	if (i&0x2)  temp += 1.0/R1;
	if (i&0x4)  temp += 1.0/R2;
	if (i&0x8)  temp += 1.0/R3;
	if (i&0x10) temp += 1.0/R4;
	if (i&0x20) temp += 1.0/R5;
	if (i&0x40) temp += 1.0/R6;
	if (i&0x80) temp += 1.0/R7;

	temp += 1.0/(double)ROPTION;

	if (temp != 0.0)
	{      
	  temp = 1.0/temp;	// this is total resistance of parallel ladder
	}

	return temp;
}





double Getdb( int pass, int shunt )
{
double rpass;
double rshunt;

    if (pass == 0) rpass = R_BYPASS;
	if (pass == 1) rpass = 1.0/(1.0/R_BYPASS+1.0/R2_BYPASS);
	if (pass == 2) rpass = 1.0/(1.0/R_BYPASS+1.0/R3_BYPASS);
	if (pass == 3) rpass = 1.0/(1.0/R_BYPASS+1.0/R2_BYPASS + 1.0/R3_BYPASS);
	
	rshunt = getladderimpedance(shunt);
      
	return  -20.0*log10(rshunt/(rshunt + 2* rpass));   
}




int main(int argc, char* argv[])
{
    int i,j;

	double table[4][255];
	
	#define NUM_POINTS_IN_TABLE 255
	
	int tablepass[NUM_POINTS_IN_TABLE];
	int tableshunt[NUM_POINTS_IN_TABLE];
	double tabledb[NUM_POINTS_IN_TABLE];
	
	double rladder;	
	double rparallel;
	double vin;
	double vout;

	double rpass0;
	double rpass1;
	double rpass2;
	double rpass3;

	FILE * pFile;
		

    
	
	
	vin = 1.0; // 1 volt input

	printf("Hello World!\n");

	Set10KVals();

	rpass0 = R_BYPASS;
	rpass1 = 1.0/(1.0/R_BYPASS+1.0/R2_BYPASS);
	rpass2 = 1.0/(1.0/R_BYPASS+1.0/R3_BYPASS);
	rpass3 = 1.0/(1.0/R_BYPASS+1.0/R2_BYPASS + 1.0/R3_BYPASS);
	
	for (i=0;i<255;i++)
	{
	  rladder = getladderimpedance(i);

      if (rladder == (double)0.0)
	  {
		rladder = 3;
	  }

      // calc the attenuation for no bypass
      vout = rladder/(rladder + 2* rpass0) * vin;	
	  table[0][i] = -20.0*log10(vout/vin);    

	  // calc the attenuation for bypass 1
      vout = rladder/(rladder + 2* rpass1) * vin;	
	  table[1][i] = -20.0*log10(vout/vin);    

	  // calc the attenuation for bypass 2
      vout = rladder/(rladder + 2* rpass2) * vin;	
	  table[2][i] = -20.0*log10(vout/vin);    

	  // calc the attenuation for both bypass 1 and bypass 2
      vout = rladder/(rladder + 2* rpass3) * vin;	
	  table[3][i] = -20.0*log10(vout/vin);      	  
	}




	// find the minimum and maximum db range
	double minimum;
	double maximum;

	minimum = 1000; // the smallest attenuation
	maximum = -1000; // the largest attenuation
	for (i=0;i<4;i++)
	{
		for (j=0;j<255;j++)
		{
		  if (table[i][j] < minimum) minimum = table[i][j];
		  if (table[i][j] > maximum ) maximum = table[i][j];
		}
	}


	  // This define how many volume settings your want 1 to 2010
	  // although I'm not sure if 2010 will fit into the 18F4220
	  // you might need to get the 18F4320
	

	double stepsize = (maximum - minimum)/NUM_POINTS_IN_TABLE;
    double current;

	current = maximum;
	
	int bestshunt;
	int bestpass;
	double bestdb;
	int cnt = 0;

	for (int k=0;k<NUM_POINTS_IN_TABLE;k++)
	{
	   	bestdb = table[0][0];
		bestshunt = 0;
		bestpass = 0;
		for (i=0;i<4;i++)
		{
			for (j=0;j<255;j++)
			{
			// search for the closest match to the current setting in the table
				if (fabs(table[i][j] - current) < fabs(bestdb - current))
				{
					// O.K. we found a better setting
					bestpass = i;
					bestshunt = j;
					bestdb = table[bestpass][bestshunt];
				}
			

			}
		}
//		TRACE("got one");
		// then store these indexes to a table	
		tablepass[cnt] = bestpass;;
	    tableshunt[cnt] = bestshunt;
		tabledb[cnt] = bestdb;
		cnt++;
	
		current -= stepsize;
	}
   













//	qsort (table, 255, sizeof(double), compare);


	
    pFile = fopen ("rtable.h","wt");
    if (pFile!=NULL)
	{
      //fputs ("fopen example",pFile);
      // print out the table to a file
      

	  fprintf(pFile,"typedef struct tab {\n");
	  fprintf(pFile,"unsigned int bypass;\n");
	  fprintf(pFile,"unsigned int shunt;\n");
	  fprintf(pFile,"};\n");

	  fprintf(pFile,"const struct tab table[] = { ");


      for (i=0;i<NUM_POINTS_IN_TABLE;i++)
	  {
		fprintf(pFile,"{%d , %d}",tablepass[i],tableshunt[i]);	     
		if (i<NUM_POINTS_IN_TABLE-1)fprintf(pFile,",");	     
		fprintf(pFile,"  // Volume Setting %d = -%f dB\n",i,tabledb[i]);	     
	  }

	  fprintf(pFile,"};\n");	     
	  fclose (pFile);
	}
	else
	{
      printf("file would not open!\n");
	}
    

///////////////////////////////////////////////////////////////////////////
	// now print out a dB table, so we can graph it
	// and print at all four resistance ladder ranges
	// even though the graph was optimized for 5K
    double db5;
	double db10;
	double db20;
	double db50;


    pFile = fopen ("rtable.dat","wt");
    if (pFile!=NULL)
	{      
      for (i=0;i<NUM_POINTS_IN_TABLE;i++)
	  {
		Set5KVals();
        db5 = Getdb( tablepass[i], tableshunt[i] );
	    
		Set10KVals();
        db10 = Getdb( tablepass[i], tableshunt[i] );

		Set20KVals();
        db20 = Getdb( tablepass[i], tableshunt[i] );

		Set50KVals();
        db50 = Getdb( tablepass[i], tableshunt[i] );

		fprintf(pFile,"%d\t-%f\t-%f\t-%f\t-%f\n",i,db5,db10,db20,db50);	     
	  }	  
	  fclose (pFile);
	}
	else
	{		
      printf("file would not open!\n");
	}
/////////////////////////////////////////////////////////////////////


   
	


	return 0;
}

